--- E:\Sandbox\Ros\freeldr\freeldr\reactos\setupldr.c	Wed Sep 01 09:06:03 2004
+++ E:\Sandbox\ros_work\freeldr\freeldr\reactos\setupldr.c	Thu Sep 09 22:16:15 2004
@@ -28,6 +28,7 @@
 #include <multiboot.h>
 #include <mm.h>
 #include <ui.h>
+#include <portio.h>
 #include <inffile.h>
 
 #include "registry.h"
@@ -302,6 +303,16 @@
   ((char *)(&mb_info.boot_device))[0] = (char)BootDrive;
   ((char *)(&mb_info.boot_device))[1] = (char)BootPartition;
 
+  if (READ_PORT_UCHAR((PUCHAR)0xe9) == 0xe9)
+  {
+    LoadOptions = "/DEBUGPORT=BOCHS /NOBOOTGUI";
+  }
+  else
+  {
+  /* Set load options */
+//  LoadOptions = "/DEBUGPORT=COM1";
+    LoadOptions = "/DEBUGPORT=COM2 /NOBOOTGUI";
+  }
 
   /* Open boot drive */
   if (!FsOpenVolume(BootDrive, BootPartition))
@@ -517,6 +528,24 @@
   if (!LoadDriver(SourcePath, "atapi.sys"))
     return;
 
+  /*
+   * Load trm390w.sys (depends on hardware detection)
+   */
+  if (!LoadDriver(SourcePath, "trm390w.sys"))
+     /*return*/;
+
+  /*
+   * Load hpt3xx.sys (depends on hardware detection)
+   */
+  if (!LoadDriver(SourcePath, "hpt3xx.sys"))
+     /*return*/;
+
+  /*
+   * Load inia100.sys (depends on hardware detection)
+   */
+  if (!LoadDriver(SourcePath, "inia100.sys"))
+     /*return*/;
+     
   /* Load class2.sys */
   if (!LoadDriver(SourcePath, "class2.sys"))
     return;
